{-# LANGUAGE KindSignatures, RankNTypes #-}
module Distributed.Model.Semantics (
   Msg(..)
 , Model
 ) where

import Data.Functor.Identity
import Data.Machine
import Data.Map (Map)

data Msg addr p =
  Msg
  { peer :: addr
  , payload :: p
  }

type Model addr p m a = PlanT (Is (Msg addr p)) (Msg addr p) m a

type DeterministicModel addr p m a = forall m. PlanT (Is (Msg addr p)) (Msg addr p) m a

-- | A protocol definting how each member of the group behaves.
type JointProtocol addr p m a = Map addr (Model addr p m a)

-- Dealing with time? m ~ IO
-- Link discovery? Some iterator? Submachine?
--   Probably GADT that asks for a set of peers, and to know about ones added
--   in addition or instead of recving a message.
